<?php
class ControllerExtensionModuleHttpmprodtc extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/httpmprodtc');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_setting_module->addModule('httpmprodtc', $this->request->post);
			} else {
				$this->model_setting_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/module/httpmprodtc', 'user_token=' . $this->session->data['user_token'], true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/httpmprodtc', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true)
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/httpmprodtc', 'user_token=' . $this->session->data['user_token'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/httpmprodtc', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true);
		}

		$data['cancel'] = $this->url->link('extension/module', 'user_token=' . $this->session->data['user_token'], true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_setting_module->getModule($this->request->get['module_id']);
		} else {
			$module_info = array();
			$module_info['tabs'] = array(
				array('id' => 1,'product' => '','tab'=>array(1), 'tname'=> '', 'category'=>''),array('id' => 1,'product' => '','tab'=>array(1), 'tname'=> '', 'category'=>'')
			);
			$module_info['items'] = '';
			$module_info['name'] = '';
			$module_info['class'] = '';
			$module_info['limit'] = '';
			$module_info['prodview'] = '';
			$module_info['width'] = '';
			$module_info['height'] = '';
			$module_info['status'] = '0';
			$module_info['displaytitle'] = '1';
		}
		$data['user_token'] = $this->session->data['user_token'];

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		$this->load->model('catalog/product');
		$tab = array();
		$tabs=array();
		$data['tabs']=array();
		if (isset($this->request->post['tabs'])) {
			$tabs = $this->request->post['tabs'];
		} else if (isset($module_info['tabs'])) {
			$tabs = $module_info['tabs'];
		}
		$i=0;
		foreach ($tabs as $tab) {
			$i++;
			$tab['id'] = $i;
			$products = array();
			if ($tab['product']) {
				foreach ($tab['product'] as $product_id) {
					$product_info = $this->model_catalog_product->getProduct($product_id);

					if ($product_info) {
						$products[] = array(
							'product_id' => $product_info['product_id'],
							'name'       => $product_info['name']
						);
					}
				}
			}

			$data['tabs'][] = array(
				'tab'          => $tab["tab"][0],
				'id' => $tab["id"],
				'tname' => $tab['tname'],
				'category' => $tab['category'],
				'product' => $products,
				'id' => $tab['id'],
			);

		}
		
		

		if (isset($this->request->post['tab'])) {
			$data['tab'] = $this->request->post['tab'][0];
		} elseif (!empty($module_info['tab'])) {
			$data['tab'] = $module_info['tab'][0];
		} else {
			$data['tab'] = '1';
		}
		if (isset($this->request->post['category']) && $data['tab'] == 2) {
			$data['scategory'] = $this->request->post['category'];
		} elseif (!empty($module_info['category'])) {
			$data['scategory'] = $module_info['category'];
		} else {
			$data['scategory'] = '';
		}

		

	




		$data['categories'] = array();
		$this->load->model('catalog/category');
		$filter_data = array(
      		'sort'  => 'name',
      		'order' => 'ASC',
		);
		$data['categories'] = $this->model_catalog_category->getCategories($filter_data);

		if (isset($this->request->post['limit'])) {
			$data['limit'] = $this->request->post['limit'];
		} elseif (!empty($module_info)) {
			$data['limit'] = $module_info['limit'];
		} else {
			$data['limit'] = 10;
		}
		if (isset($this->request->post['items'])) {
			$data['items'] = $this->request->post['items'];
		} elseif (!empty($module_info)) {
			$data['items'] = $module_info['items'];
		} else {
			$data['items'] = 4;
		}

		if (isset($this->request->post['class'])) {
			$data['class'] = $this->request->post['class'];
		} elseif (!empty($module_info)) {
			$data['class'] = $module_info['class'];
		} else {
			$data['class'] = '';
		}

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = 200;
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = 200;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}


		if (isset($this->request->post['prodview'])) {
			$data['prodview'] = $this->request->post['prodview'];
		} elseif (!empty($module_info)) {
			$data['prodview'] = $module_info['prodview'];
		} else {
			$data['prodview'] = '0';
		}

		if (isset($this->request->post['displaytitle'])) {
			$data['displaytitle'] = $this->request->post['displaytitle'];
		} elseif (!empty($module_info)) {
			$data['displaytitle'] = $module_info['displaytitle'];
		} else {
			$data['displaytitle'] = '';
		}

		
		

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/httpmprodtc', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/httpmprodtc')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		if (!$this->request->post['width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['height']) {
			$this->error['height'] = $this->language->get('error_height');
		}

		return !$this->error;
	}
}